# coding: utf-8

"""
    Oneloop API

    API Key Management

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conint, conlist
from oneloop_client.models.api_key_scope import ApiKeyScope

class CreateApiKeyRequest(BaseModel):
    """
    CreateApiKeyRequest
    """
    name: StrictStr = Field(...)
    workspace_id: StrictStr = Field(default=..., alias="workspaceId")
    prefix: Optional[StrictStr] = None
    expires_at: Optional[conint(strict=True, gt=0)] = Field(default=None, alias="expiresAt")
    total_usage_allowed: Optional[conint(strict=True, gt=0)] = Field(default=None, alias="totalUsageAllowed")
    scopes: conlist(ApiKeyScope) = Field(...)
    enabled: StrictBool = Field(...)
    customer_id: StrictStr = Field(default=..., alias="customerId")
    __properties = ["name", "workspaceId", "prefix", "expiresAt", "totalUsageAllowed", "scopes", "enabled", "customerId"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateApiKeyRequest:
        """Create an instance of CreateApiKeyRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in scopes (list)
        _items = []
        if self.scopes:
            for _item in self.scopes:
                if _item:
                    _items.append(_item.to_dict())
            _dict['scopes'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateApiKeyRequest:
        """Create an instance of CreateApiKeyRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateApiKeyRequest.parse_obj(obj)

        _obj = CreateApiKeyRequest.parse_obj({
            "name": obj.get("name"),
            "workspace_id": obj.get("workspaceId"),
            "prefix": obj.get("prefix"),
            "expires_at": obj.get("expiresAt"),
            "total_usage_allowed": obj.get("totalUsageAllowed"),
            "scopes": [ApiKeyScope.from_dict(_item) for _item in obj.get("scopes")] if obj.get("scopes") is not None else None,
            "enabled": obj.get("enabled"),
            "customer_id": obj.get("customerId")
        })
        return _obj


